searchData={"items":[{"type":"module","title":"Dreamy","doc":"Dreamy provides useful macros & operators to make elixir even more dreamy","ref":"Dreamy.html"},{"type":"macro","title":"Dreamy.>>>/2","doc":"Operator short hand for Enum.map","ref":"Dreamy.html#%3E%3E%3E/2"},{"type":"macro","title":"Examples - Dreamy.>>>/2","doc":"```\niex> use Dreamy\n...> x = fn y -> y + 1 end\n...> [1, 2]\n...> >>> (&IO.inspect/1)\n...> >>> x\n[2, 3]\n```","ref":"Dreamy.html#%3E%3E%3E/2-examples"},{"type":"macro","title":"Dreamy.const/2","doc":"Macro for defining a constant attribute and function","ref":"Dreamy.html#const/2"},{"type":"macro","title":"Examples - Dreamy.const/2","doc":"```\niex> use Dreamy\niex> const :example, \"XYZ\"\niex> @example\n\"XYZ\"\n\niex> example()\n\"XYZ\"\n```","ref":"Dreamy.html#const/2-examples"},{"type":"macro","title":"Dreamy.fallthrough/2","doc":"Macro for adding a default catchall -> clause to case statements, that returns the input value","ref":"Dreamy.html#fallthrough/2"},{"type":"macro","title":"Examples - Dreamy.fallthrough/2","doc":"```\niex> use Dreamy\n...> fallthrough 1 do\n...> 2 -> 2\n...> end\n1\n\niex> use Dreamy\n...> fallthrough 2 do\n...> 2 -> 2\n...> end\n2\n```","ref":"Dreamy.html#fallthrough/2-examples"},{"type":"function","title":"Dreamy.flip/1","doc":"Function for flipping results","ref":"Dreamy.html#flip/1"},{"type":"function","title":"Examples - Dreamy.flip/1","doc":"```\niex> use Dreamy\n...> flip({:ok, 3})\n{:error, 3}\n\niex> use Dreamy\n...> flip({:error, 3})\n{:ok, 3}\n```","ref":"Dreamy.html#flip/1-examples"},{"type":"macro","title":"Dreamy.otherwise/3","doc":"Macro for adding a default catchall -> clause to case statements, that returns the default value","ref":"Dreamy.html#otherwise/3"},{"type":"macro","title":"Examples - Dreamy.otherwise/3","doc":"```\niex> use Dreamy\n...> otherwise 1, nil do\n...> 2 -> 2\n...> end\nnil\n\niex> use Dreamy\n...> otherwise 2, nil do\n...> 2 -> 2\n...> end\n2\n```","ref":"Dreamy.html#otherwise/3-examples"},{"type":"function","title":"Dreamy.through/2","doc":"function for applying anonymous functions","ref":"Dreamy.html#through/2"},{"type":"function","title":"Examples - Dreamy.through/2","doc":"```\niex> use Dreamy\niex> 2 |>\niex> through(fn x -> x - 1 end) |>\niex> through(fn x -> x - 1 end)\n0\n```","ref":"Dreamy.html#through/2-examples"},{"type":"function","title":"Dreamy.unwrap/1","doc":"Function for extracting values from :ok records","ref":"Dreamy.html#unwrap/1"},{"type":"function","title":"Examples - Dreamy.unwrap/1","doc":"```\niex> use Dreamy\n...> {:ok, \"hello\"} |> unwrap\n\"hello\"\n\niex> use Dreamy\n...> {:error, \"world\"} |> unwrap\n{:error, \"world\"}\n```","ref":"Dreamy.html#unwrap/1-examples"},{"type":"function","title":"Dreamy.unwrap_error/1","doc":"Function for extracting values from :error tuples","ref":"Dreamy.html#unwrap_error/1"},{"type":"function","title":"Examples - Dreamy.unwrap_error/1","doc":"```\niex> use Dreamy\n...> {:ok, \"hello\"} |> unwrap_error\n{:ok, \"hello\"}\n\niex> use Dreamy\n...> {:error, \"world\"} |> unwrap_error\n\"world\"\n```","ref":"Dreamy.html#unwrap_error/1-examples"},{"type":"function","title":"Dreamy.~>/2","doc":"Function for applying result tuples on success only","ref":"Dreamy.html#~%3E/2"},{"type":"function","title":"Examples - Dreamy.~>/2","doc":"```\niex> use Dreamy\n...> {:ok, 1} ~>\n...> fn x -> {:ok, x + 1} end ~>\n...> fn y -> y + 1 end\n3\n\niex> use Dreamy\n...> {:error, 1} ~> fn x -> x + 1 end\n{:error, 1}\n```","ref":"Dreamy.html#~%3E/2-examples"},{"type":"function","title":"Dreamy.~>>/2","doc":"Function for applying result tuples on success only","ref":"Dreamy.html#~%3E%3E/2"},{"type":"function","title":"Examples - Dreamy.~>>/2","doc":"```\niex> use Dreamy\n...> {:ok, 1} ~>>\n...> fn {:ok, x} -> {:ok, x + 1} end ~>>\n...> fn {:ok, x} -> {:ok, x + 1} end\n{:ok, 3}\n\niex> use Dreamy\n...> {:error, 1} ~>> fn {:ok, x} -> {:ok, x + 1} end\n{:error, 1}\n```","ref":"Dreamy.html#~%3E%3E/2-examples"},{"type":"module","title":"Dreamy.Types","doc":"Useful Type definitions","ref":"Dreamy.Types.html"},{"type":"type","title":"Dreamy.Types.nullable/1","doc":"","ref":"Dreamy.Types.html#t:nullable/1"},{"type":"type","title":"Dreamy.Types.result/2","doc":"","ref":"Dreamy.Types.html#t:result/2"},{"type":"extras","title":"Dreamy","doc":"# Dreamy\n\nDreamy provides useful macros & operators to make elixir even more dreamy. 😴","ref":"readme.html"},{"type":"extras","title":"Installation - Dreamy","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `dreamy` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:dreamy, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at [https://hexdocs.pm/dreamy](https://hexdocs.pm/dreamy).","ref":"readme.html#installation"}],"content_type":"text/markdown"}